VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "DOCX to HTML  Converter Demo"
   ClientHeight    =   2745
   ClientLeft      =   135
   ClientTop       =   510
   ClientWidth     =   4920
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   2745
   ScaleWidth      =   4920
   Begin VB.CommandButton OK 
      Caption         =   "OK"
      Height          =   375
      Left            =   3360
      TabIndex        =   6
      Top             =   2160
      Width           =   1335
   End
   Begin VB.CommandButton Cancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   1800
      TabIndex        =   5
      Top             =   2160
      Width           =   1335
   End
   Begin VB.CheckBox TransferAsBuffer 
      Caption         =   "Transfer file in a buffer"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   1680
      Width           =   2175
   End
   Begin VB.TextBox OutputFile 
      Height          =   285
      Left            =   120
      TabIndex        =   3
      Top             =   1200
      Width           =   4575
   End
   Begin VB.TextBox InputFile 
      Height          =   285
      Left            =   120
      TabIndex        =   2
      Top             =   360
      Width           =   4575
   End
   Begin VB.Label status 
      Alignment       =   1  'Right Justify
      Height          =   255
      Left            =   2880
      TabIndex        =   7
      Top             =   1680
      Width           =   1815
   End
   Begin VB.Label Label3 
      Caption         =   "Output File Name (*.htm)"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   960
      Width           =   3255
   End
   Begin VB.Label Label1 
      Caption         =   "Input File Name (*.docx)"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3135
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Sub Text1_Change()

End Sub



Private Sub Cancel_Click()
   Unload Form1
End Sub

Private Sub OK_Click()
   Dim FileString As String
   Dim OutString As String
   Dim hMem As Long
   Dim OutSize As Long
   Dim result As Boolean
   Dim id As Long
   
   
   ' Check if file exists
   If Not ReadFile(InputFile.Text, FileString, False) Then ' check if file exists
      InputFile.SetFocus
      Exit Sub
   End If
   If OutputFile.Text = "" Then
      OutputFile.SetFocus
      Exit Sub
   End If
      
   Status.Caption = "Converting...."   ' show the progress status
   result = False
   
      
   ' Do file conversion
   id = DhsNewSession()   ' start a new conversion session
   
   If TransferAsBuffer.Value = 1 Then  ' do conversion after reading the file in a string
     Call ReadFile(InputFile.Text, FileString, True) ' read the file in a string
     
     hMem = DhsConvertBuffer(id, FileString, Len(FileString), OutSize)
     If (hMem <> 0) Then
        OutString = Space$(OutSize + 1) ' allocate space for the output string
        Call DhsHandleToStr(OutString, OutSize, hMem)
        If WriteFile(OutputFile.Text, OutString, OutSize) Then result = True
     End If
   Else              ' do the file conversion
     If (DhsConvertFile(id, InputFile.Text, OutputFile.Text)) Then result = True
   End If
      
   DhsEndSession (id) ' end conversion session
   If (result) Then Status.Caption = "Done!" Else Status.Caption = "Error"
      
      
End Sub

Function ReadFile(ByVal FileName As String, FileString As String, ByVal DoRead As Boolean) As Boolean
   Dim iFile As Integer

   FileString = ""
   ReadFile = False
   
   Rem open the input file
   iFile = 1
   ErrorCode = 0
   On Error GoTo RtfErrorHandler
   Open FileName For Binary As iFile
   On Error GoTo 0
   If ErrorCode Then
      MsgBox "Input File Not Found"
      Exit Function
   End If
   
   If (DoRead) Then FileString = Input(FileLen(FileName), iFile)  ' 6 bytes already read
   
   Close #iFile
   
   ReadFile = True
   
   Exit Function

RtfErrorHandler:
   ErrorCode = Err
   Resume Next

   
End Function

Function WriteFile(ByVal FileName As String, DataString As String, ByVal DataSize) As Boolean
   Dim iFile As Integer

   WriteFile = False
      
   On Error GoTo OutErrorHandler
   Kill FileName   ' delete any existing file
   
   Rem open the input file
   iFile = 1
   ErrorCode = 0
   On Error GoTo OutErrorHandler
   Open FileName For Binary Access Write As iFile
   On Error GoTo 0
   If ErrorCode Then
      MsgBox "Output file can not be opened!"
      Exit Function
   End If
   
   Put #iFile, , DataString
   
   Close #iFile
   
   WriteFile = True
   
   Exit Function

OutErrorHandler:
   ErrorCode = Err
   Resume Next

   
End Function

